diff --git a/src/libs/zbxcrypto/tls.c b/src/libs/zbxcrypto/tls.c
index 7338883..b720452 100644
--- a/src/libs/zbxcrypto/tls.c
+++ b/src/libs/zbxcrypto/tls.c
@@ -19,7 +19,7 @@
 
 #include "common.h"
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 
 #include "comms.h"
 #include "threads.h"
@@ -36,6 +36,15 @@
 #	include <polarssl/debug.h>
 #	include <polarssl/oid.h>
 #	include <polarssl/version.h>
+#elif defined(HAVE_MBEDTLS21)
+#	include <mbedtls/entropy.h>
+#	include <mbedtls/ctr_drbg.h>
+#	include <mbedtls/ssl.h>
+#	include <mbedtls/error.h>
+#	include <mbedtls/debug.h>
+#	include <mbedtls/oid.h>
+#	include <mbedtls/net.h>
+#	include <mbedtls/version.h>
 #elif defined(HAVE_GNUTLS)
 #	include <gnutls/gnutls.h>
 #	include <gnutls/x509.h>
@@ -55,6 +64,14 @@
 #	define ZBX_TLS_CIPHERSUITE_CERT	0			/* select only certificate ciphersuites */
 #	define ZBX_TLS_CIPHERSUITE_PSK	1			/* select only pre-shared key ciphersuites */
 #	define ZBX_TLS_CIPHERSUITE_ALL	2			/* select ciphersuites with certificate and PSK */
+#elif defined(HAVE_MBEDTLS21)
+#	define ZBX_TLS_MIN_MAJOR_VER	MBEDTLS_SSL_MAJOR_VERSION_3
+#	define ZBX_TLS_MIN_MINOR_VER	MBEDTLS_SSL_MINOR_VERSION_3
+#	define ZBX_TLS_MAX_MAJOR_VER	MBEDTLS_SSL_MAJOR_VERSION_3
+#	define ZBX_TLS_MAX_MINOR_VER	MBEDTLS_SSL_MINOR_VERSION_3
+#	define ZBX_TLS_CIPHERSUITE_CERT	0			/* select only certificate ciphersuites */
+#	define ZBX_TLS_CIPHERSUITE_PSK	1			/* select only pre-shared key ciphersuites */
+#	define ZBX_TLS_CIPHERSUITE_ALL	2			/* select ciphersuites with certificate and PSK */
 #endif
 
 #if defined(HAVE_OPENSSL) && OPENSSL_VERSION_NUMBER < 0x1010000fL	/* for OpenSSL 1.0.1/1.0.2 (before 1.1.0) */
@@ -153,6 +170,9 @@ struct zbx_tls_context
 {
 #if defined(HAVE_POLARSSL)
 	ssl_context			*ctx;
+#elif defined(HAVE_MBEDTLS21)
+	mbedtls_ssl_config			*conf;
+	mbedtls_ssl_context			*ctx;
 #elif defined(HAVE_GNUTLS)
 	gnutls_session_t		ctx;
 	gnutls_psk_client_credentials_t	psk_client_creds;
@@ -202,6 +222,17 @@ ZBX_THREAD_LOCAL static char			*err_msg		= NULL;
 ZBX_THREAD_LOCAL static int			*ciphersuites_cert	= NULL;
 ZBX_THREAD_LOCAL static int			*ciphersuites_psk	= NULL;
 ZBX_THREAD_LOCAL static int			*ciphersuites_all	= NULL;
+#elif defined(HAVE_MBEDTLS21)
+ZBX_THREAD_LOCAL static mbedtls_x509_crt		*ca_cert		= NULL;
+ZBX_THREAD_LOCAL static mbedtls_x509_crl		*crl			= NULL;
+ZBX_THREAD_LOCAL static mbedtls_x509_crt		*my_cert		= NULL;
+ZBX_THREAD_LOCAL static mbedtls_pk_context		*my_priv_key		= NULL;
+ZBX_THREAD_LOCAL static mbedtls_entropy_context		*entropy		= NULL;
+ZBX_THREAD_LOCAL static mbedtls_ctr_drbg_context	*ctr_drbg		= NULL;
+ZBX_THREAD_LOCAL static char			*err_msg		= NULL;
+ZBX_THREAD_LOCAL static int			*ciphersuites_cert	= NULL;
+ZBX_THREAD_LOCAL static int			*ciphersuites_psk	= NULL;
+ZBX_THREAD_LOCAL static int			*ciphersuites_all	= NULL;
 #elif defined(HAVE_GNUTLS)
 ZBX_THREAD_LOCAL static gnutls_certificate_credentials_t	my_cert_creds		= NULL;
 ZBX_THREAD_LOCAL static gnutls_psk_client_credentials_t		my_psk_client_creds	= NULL;
@@ -235,8 +266,7 @@ ZBX_THREAD_LOCAL char				info_buf[256];
  * Comments:                                                                      *
  *     For more information about why and how to use personalization strings see  *
  *     https://polarssl.org/module-level-design-rng                               *
- *     http://nvlpubs.nist.gov/nistpubs/SpecialPublications/NIST.SP.800-90Ar1.pdf *
- *                                                                                *
+ *     http://nvlpubs.nist.gov/nistpubs/SpecialPublications/NIST.SP *                                                                                *
  **********************************************************************************/
 static void	zbx_make_personalization_string(unsigned char pers[64])
 {
@@ -258,6 +288,39 @@ static void	zbx_make_personalization_string(unsigned char pers[64])
 	sha512_finish(&ctx, pers);
 	sha512_free(&ctx);
 }
+#elif defined(HAVE_MBEDTLS21)
+/**********************************************************************************
+ *                                                                                *
+ * Function: zbx_make_personalization_string                                      *
+ *                                                                                *
+ * Purpose: provide additional entropy for initialization of crypto library       *
+ *                                                                                *
+ * Comments:                                                                      *
+ *     For more information about why and how to use personalization strings see  *
+ *     https://polarssl.org/module-level-design-rng                               *
+ *     http://nvlpubs.nist.gov/nistpubs/SpecialPublications/NIST.SP.800-90Ar1.pdf *
+ *                                                                                *
+ **********************************************************************************/
+static void	zbx_make_personalization_string(unsigned char pers[64])
+{
+	long int	thread_id;
+	zbx_timespec_t	ts;
+	mbedtls_sha512_context	ctx;
+
+	mbedtls_sha512_init(&ctx);
+	mbedtls_sha512_starts(&ctx, 1);		/* use SHA-384 mode */
+
+	thread_id = zbx_get_thread_id();
+	mbedtls_sha512_update(&ctx, (const unsigned char *)&thread_id, sizeof(thread_id));
+
+	zbx_timespec(&ts);
+
+	if (0 != ts.ns)
+		mbedtls_sha512_update(&ctx, (const unsigned char *)&ts.ns, sizeof(ts.ns));
+
+	mbedtls_sha512_finish(&ctx, pers);
+	mbedtls_sha512_free(&ctx);
+}
 #endif
 
 #if defined(HAVE_POLARSSL)
@@ -281,6 +344,27 @@ static void	polarssl_debug_cb(void *tls_ctx, int level, const char *str)
 	zbx_rtrim(msg, "\n");
 	zabbix_log(LOG_LEVEL_TRACE, "PolarSSL debug: level=%d \"%s\"", level, msg);
 }
+#elif defined(HAVE_MBEDTLS21)
+/******************************************************************************
+ *                                                                            *
+ * Function: polarssl_debug_cb                                                *
+ *                                                                            *
+ * Purpose: write a PolarSSL debug message into Zabbix log                    *
+ *                                                                            *
+ * Comments:                                                                  *
+ *     Parameter 'tls_ctx' is not used but cannot be removed because this is  *
+ *     a callback function, its arguments are defined in PolarSSL.            *
+ *                                                                            *
+ ******************************************************************************/
+static void	polarssl_debug_cb(void *tls_ctx, int level, const char *filename, int lineno, const char *str)
+{
+	char	msg[1024];	/* Apparently 1024 bytes is the longest message which can come from PolarSSL 1.3.9 */
+
+	/* remove '\n' from the end of debug message */
+	zbx_strlcpy(msg, str, sizeof(msg));
+	zbx_rtrim(msg, "\n");
+	zabbix_log(LOG_LEVEL_TRACE, "PolarSSL debug: level=%d filename=%s lineno=%d \"%s\"", level, filename, lineno, msg);
+}
 #elif defined(HAVE_GNUTLS)
 /******************************************************************************
  *                                                                            *
@@ -392,6 +476,14 @@ static void	zbx_tls_error_msg(int error_code, const char *msg, char **error)
 	polarssl_strerror(error_code, err, sizeof(err));
 	*error = zbx_dsprintf(*error, "%s%s", msg, err);
 }
+#elif defined(HAVE_MBEDTLS21)
+static void	zbx_tls_error_msg(int error_code, const char *msg, char **error)
+{
+	char	err[128];	/* 128 bytes are enough for PolarSSL error messages */
+
+	mbedtls_strerror(error_code, err, sizeof(err));
+	*error = zbx_dsprintf(*error, "%s%s", msg, err);
+}
 #elif defined(HAVE_OPENSSL)
 void	zbx_tls_error_msg(char **error, size_t *error_alloc, size_t *error_offset)
 {
@@ -469,6 +561,58 @@ static void	zbx_tls_cert_error_msg(unsigned int flags, char **error)
 		i++;
 	}
 }
+#elif defined(HAVE_MBEDTLS21)
+/******************************************************************************
+ *                                                                            *
+ * Function: zbx_tls_cert_error_msg                                           *
+ *                                                                            *
+ * Purpose:                                                                   *
+ *     compose a certificate validation error message by decoding PolarSSL    *
+ *     mbedtls_ssl_get_verify_result() return value                           *
+ *                                                                            *
+ * Parameters:                                                                *
+ *     flags   - [IN] result returned by PolarSSL                             *
+ *                    mbedtls_ssl_get_verify_result()                         *
+ *     error   - [OUT] dynamically allocated memory with error message        *
+ *                                                                            *
+ ******************************************************************************/
+static void	zbx_tls_cert_error_msg(unsigned int flags, char **error)
+{
+	const unsigned int	bits[] = { MBEDTLS_X509_BADCERT_EXPIRED, MBEDTLS_X509_BADCERT_REVOKED, MBEDTLS_X509_BADCERT_CN_MISMATCH,
+				MBEDTLS_X509_BADCERT_NOT_TRUSTED, MBEDTLS_X509_BADCRL_NOT_TRUSTED,
+				MBEDTLS_X509_BADCRL_EXPIRED, MBEDTLS_X509_BADCERT_MISSING, MBEDTLS_X509_BADCERT_SKIP_VERIFY, MBEDTLS_X509_BADCERT_OTHER,
+				MBEDTLS_X509_BADCERT_FUTURE, MBEDTLS_X509_BADCRL_FUTURE,
+				MBEDTLS_X509_BADCERT_KEY_USAGE, MBEDTLS_X509_BADCERT_EXT_KEY_USAGE, MBEDTLS_X509_BADCERT_NS_CERT_TYPE,
+				0 };
+	const char		*msgs[] = { "expired", "revoked", "Common Name mismatch",
+				"self-signed or not signed by trusted CA", "CRL not signed by trusted CA",
+				"CRL expired", "certificate missing", "verification skipped", "other reason",
+				"validity starts in future", "CRL validity starts in future"
+				, "actual use does not match keyUsage extension",
+				"actual use does not match extendedKeyUsage extension",
+				"actual use does not match nsCertType extension"
+				};
+	int			i = 0, k = 0;
+
+	*error = zbx_strdup(*error, "invalid peer certificate: ");
+
+	while (0 != flags && 0 != bits[i])
+	{
+		if (0 != (flags & bits[i]))
+		{
+			flags &= ~bits[i];	/* reset the checked bit to detect no-more-set-bits without checking */
+						/* every bit */
+			if (0 != k)
+				*error = zbx_strdcat(*error, ", ");
+			else
+				k = 1;
+
+			*error = zbx_strdcat(*error, msgs[i]);
+		}
+
+		i++;
+	}
+}
 #endif
 
 /******************************************************************************
@@ -1074,6 +1218,171 @@ static unsigned int	zbx_ciphersuites(int type, int **suites)
 
 	return count;
 }
+#elif defined(HAVE_MBEDTLS21)
+/******************************************************************************
+ *                                                                            *
+ * Function: zbx_is_ciphersuite_cert                                          *
+ *                                                                            *
+ * Purpose: does the specified ciphersuite ID refer to a non-PSK              *
+ *          (i.e. certificate) ciphersuite supported for the specified TLS    *
+ *          version range                                                     *
+ *                                                                            *
+ * Comments:                                                                  *
+ *          RFC 7465 "Prohibiting RC4 Cipher Suites" requires that RC4 should *
+ *          never be used. Also, discard weak encryptions.                    *
+ *                                                                            *
+ ******************************************************************************/
+static int	zbx_is_ciphersuite_cert(const int *p)
+{
+	const mbedtls_ssl_ciphersuite_t	*info;
+
+	/* PolarSSL function mbedtls_ssl_ciphersuite_uses_psk() is not used here because it can be unavailable in some */
+	/* installations. */
+	if (NULL != (info = mbedtls_ssl_ciphersuite_from_id(*p)) && (MBEDTLS_KEY_EXCHANGE_ECDHE_RSA == info->key_exchange ||
+			MBEDTLS_KEY_EXCHANGE_RSA == info->key_exchange) &&
+			(MBEDTLS_CIPHER_AES_128_GCM == info->cipher || MBEDTLS_CIPHER_AES_128_CBC == info->cipher) &&
+			0 == (info->flags & MBEDTLS_CIPHERSUITE_WEAK) &&
+			(ZBX_TLS_MIN_MAJOR_VER > info->min_major_ver || (ZBX_TLS_MIN_MAJOR_VER == info->min_major_ver &&
+			ZBX_TLS_MIN_MINOR_VER >= info->min_minor_ver)) &&
+			(ZBX_TLS_MAX_MAJOR_VER < info->max_major_ver || (ZBX_TLS_MAX_MAJOR_VER == info->max_major_ver &&
+			ZBX_TLS_MAX_MINOR_VER <= info->max_minor_ver)))
+	{
+		return SUCCEED;
+	}
+	else
+		return FAIL;
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Function: zbx_is_ciphersuite_psk                                           *
+ *                                                                            *
+ * Purpose: does the specified ciphersuite ID refer to a PSK ciphersuite      *
+ *          supported for the specified TLS version range                     *
+ *                                                                            *
+ * Comments:                                                                  *
+ *          RFC 7465 "Prohibiting RC4 Cipher Suites" requires that RC4 should *
+ *          never be used. Also, discard weak encryptions.                    *
+ *                                                                            *
+ ******************************************************************************/
+static int	zbx_is_ciphersuite_psk(const int *p)
+{
+	const mbedtls_ssl_ciphersuite_t	*info;
+
+	if (NULL != (info = mbedtls_ssl_ciphersuite_from_id(*p)) && (MBEDTLS_KEY_EXCHANGE_ECDHE_PSK == info->key_exchange ||
+			MBEDTLS_KEY_EXCHANGE_PSK == info->key_exchange) &&
+			(MBEDTLS_CIPHER_AES_128_GCM == info->cipher || MBEDTLS_CIPHER_AES_128_CBC == info->cipher) &&
+			0 == (info->flags & MBEDTLS_CIPHERSUITE_WEAK) &&
+			(ZBX_TLS_MIN_MAJOR_VER > info->min_major_ver || (ZBX_TLS_MIN_MAJOR_VER == info->min_major_ver &&
+			ZBX_TLS_MIN_MINOR_VER >= info->min_minor_ver)) &&
+			(ZBX_TLS_MAX_MAJOR_VER < info->max_major_ver || (ZBX_TLS_MAX_MAJOR_VER == info->max_major_ver &&
+			ZBX_TLS_MAX_MINOR_VER <= info->max_minor_ver)))
+	{
+		return SUCCEED;
+	}
+	else
+		return FAIL;
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Function: zbx_is_ciphersuite_all                                           *
+ *                                                                            *
+ * Purpose: does the specified ciphersuite ID refer to a good ciphersuite     *
+ *          supported for the specified TLS version range                     *
+ *                                                                            *
+ * Comments:                                                                  *
+ *          RFC 7465 "Prohibiting RC4 Cipher Suites" requires that RC4 should *
+ *          never be used. Also, discard weak encryptions.                    *
+ *                                                                            *
+ ******************************************************************************/
+static int	zbx_is_ciphersuite_all(const int *p)
+{
+	const mbedtls_ssl_ciphersuite_t	*info;
+
+	if (NULL != (info = mbedtls_ssl_ciphersuite_from_id(*p)) && (MBEDTLS_KEY_EXCHANGE_ECDHE_RSA == info->key_exchange ||
+			MBEDTLS_KEY_EXCHANGE_RSA == info->key_exchange ||
+			MBEDTLS_KEY_EXCHANGE_ECDHE_PSK == info->key_exchange ||
+			MBEDTLS_KEY_EXCHANGE_PSK == info->key_exchange) &&
+			(MBEDTLS_CIPHER_AES_128_GCM == info->cipher || MBEDTLS_CIPHER_AES_128_CBC == info->cipher) &&
+			0 == (info->flags & MBEDTLS_CIPHERSUITE_WEAK) &&
+			(ZBX_TLS_MIN_MAJOR_VER > info->min_major_ver || (ZBX_TLS_MIN_MAJOR_VER == info->min_major_ver &&
+			ZBX_TLS_MIN_MINOR_VER >= info->min_minor_ver)) &&
+			(ZBX_TLS_MAX_MAJOR_VER < info->max_major_ver || (ZBX_TLS_MAX_MAJOR_VER == info->max_major_ver &&
+			ZBX_TLS_MAX_MINOR_VER <= info->max_minor_ver)))
+	{
+		return SUCCEED;
+	}
+	else
+		return FAIL;
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Function: zbx_ciphersuites                                                 *
+ *                                                                            *
+ * Purpose: copy a list of ciphersuites (certificate or PSK-related) from a   *
+ *          list of all supported ciphersuites                                *
+ *                                                                            *
+ ******************************************************************************/
+static unsigned int	zbx_ciphersuites(int type, int **suites)
+{
+	const int	*supported_suites, *p;
+	int		*q;
+	unsigned int	count = 0;
+
+	supported_suites = mbedtls_ssl_list_ciphersuites();
+
+	/* count available relevant ciphersuites */
+	for (p = supported_suites; 0 != *p; p++)
+	{
+		if (ZBX_TLS_CIPHERSUITE_CERT == type)
+		{
+			if (SUCCEED != zbx_is_ciphersuite_cert(p))
+				continue;
+		}
+		else if (ZBX_TLS_CIPHERSUITE_PSK == type)
+		{
+			if (SUCCEED != zbx_is_ciphersuite_psk(p))
+				continue;
+		}
+		else	/* ZBX_TLS_CIPHERSUITE_ALL */
+		{
+			if (SUCCEED != zbx_is_ciphersuite_all(p))
+				continue;
+		}
+
+		count++;
+	}
+
+	*suites = zbx_malloc(*suites, (count + 1) * sizeof(int));
+
+	/* copy the ciphersuites into array */
+	for (p = supported_suites, q = *suites; 0 != *p; p++)
+	{
+		if (ZBX_TLS_CIPHERSUITE_CERT == type)
+		{
+			if (SUCCEED != zbx_is_ciphersuite_cert(p))
+				continue;
+		}
+		else if (ZBX_TLS_CIPHERSUITE_PSK == type)
+		{
+			if (SUCCEED != zbx_is_ciphersuite_psk(p))
+				continue;
+		}
+		else	/* ZBX_TLS_CIPHERSUITE_ALL */
+		{
+			if (SUCCEED != zbx_is_ciphersuite_all(p))
+				continue;
+		}
+
+		*q++ = *p;
+	}
+
+	*q = 0;
+
+	return count;
+}
 #endif
 
 /******************************************************************************
@@ -1228,23 +1537,123 @@ static int	zbx_psk_cb(void *par, ssl_context *tls_ctx, const unsigned char *psk_
 
 	return -1;
 }
-#elif defined(HAVE_GNUTLS)
+#elif defined(HAVE_MBEDTLS21)
 /******************************************************************************
  *                                                                            *
  * Function: zbx_psk_cb                                                       *
  *                                                                            *
  * Purpose:                                                                   *
- *     find and set the requested pre-shared key upon GnuTLS request          *
+ *     find and set the requested pre-shared key upon PolarSSL request        *
  *                                                                            *
  * Parameters:                                                                *
- *     session      - [IN] not used                                           *
- *     psk_identity - [IN] PSK identity for which the PSK should be searched  *
- *                         and set                                            *
- *     key          - [OUT pre-shared key allocated and set                   *
- *                                                                            *
- * Return value:                                                              *
- *     0  - required PSK successfully found and set                           *
- *     -1 - an error occurred                                                 *
+ *     par              - [IN] not used                                       *
+ *     tls_ctx          - [IN] TLS connection context                         *
+ *     psk_identity     - [IN] PSK identity for which the PSK should be       *
+ *                             searched and set                               *
+ *     psk_identity_len - [IN] size of 'psk_identity'                         *
+ *                                                                            *
+ * Return value:                                                              *
+ *     0  - required PSK successfully found and set                           *
+ *     -1 - an error occurred                                                 *
+ *                                                                            *
+ * Comments:                                                                  *
+ *     A callback function, its arguments are defined in PolarSSL.            *
+ *     Used only in server and proxy.                                         *
+ *                                                                            *
+ ******************************************************************************/
+static int	zbx_psk_cb(void *par, mbedtls_ssl_context *tls_ctx, const unsigned char *psk_identity,
+		size_t psk_identity_len)
+{
+	const char	*__function_name = "zbx_psk_cb";
+	unsigned char	*psk;
+	size_t		psk_len = 0;
+	int		psk_bin_len;
+	unsigned char	tls_psk_identity[HOST_TLS_PSK_IDENTITY_LEN_MAX], tls_psk_hex[HOST_TLS_PSK_LEN_MAX],
+			psk_buf[HOST_TLS_PSK_LEN / 2];
+
+	if (SUCCEED == zabbix_check_log_level(LOG_LEVEL_DEBUG))
+	{
+		/* special print: psk_identity is not '\0'-terminated */
+		zabbix_log(LOG_LEVEL_DEBUG, "%s() requested PSK identity \"%.*s\"", __function_name,
+				(int)psk_identity_len, psk_identity);
+	}
+
+	/* try PSK from configuration file first (it is already in binary form) */
+
+	if (0 < my_psk_identity_len && my_psk_identity_len == psk_identity_len &&
+			0 == memcmp(my_psk_identity, psk_identity, psk_identity_len))
+	{
+		psk = (unsigned char *)my_psk;
+		psk_len = my_psk_len;
+	}
+	else	/* search the required PSK in configuration cache */
+	{
+		if (HOST_TLS_PSK_IDENTITY_LEN < psk_identity_len)
+		{
+			THIS_SHOULD_NEVER_HAPPEN;
+			return -1;
+		}
+
+		memcpy(tls_psk_identity, psk_identity, psk_identity_len);
+		tls_psk_identity[psk_identity_len] = '\0';
+
+		/* call the function DCget_psk_by_identity() by pointer */
+		if (0 < find_psk_in_cache(tls_psk_identity, tls_psk_hex, sizeof(tls_psk_hex)))
+		{
+			/* convert PSK to binary form */
+			if (0 >= (psk_bin_len = zbx_psk_hex2bin(tls_psk_hex, psk_buf, sizeof(psk_buf))))
+			{
+				/* this should have been prevented by validation in frontend or API */
+				zabbix_log(LOG_LEVEL_WARNING, "cannot convert PSK to binary form for PSK identity"
+						" \"%.*s\"", (int)psk_identity_len, psk_identity);
+				return -1;
+			}
+
+			psk = psk_buf;
+			psk_len = (size_t)psk_bin_len;
+		}
+		else
+		{
+			if (SUCCEED == zabbix_check_log_level(LOG_LEVEL_DEBUG))
+			{
+				zabbix_log(LOG_LEVEL_DEBUG, "%s() cannot find requested PSK identity \"%.*s\"",
+						__function_name, (int)psk_identity_len, psk_identity);
+			}
+		}
+	}
+
+	if (0 < psk_len)
+	{
+		int 	res;
+
+		if (0 == (res = mbedtls_ssl_set_hs_psk(tls_ctx, psk, psk_len)))
+			return 0;
+
+		zbx_tls_error_msg(res, "", &err_msg);
+		zabbix_log(LOG_LEVEL_WARNING, "cannot set PSK for PSK identity \"%.*s\": %s", (int)psk_identity_len,
+				psk_identity, err_msg);
+		zbx_free(err_msg);
+	}
+
+	return -1;
+}
+#elif defined(HAVE_GNUTLS)
+/******************************************************************************
+ *                                                                            *
+ * Function: zbx_psk_cb                                                       *
+ *                                                                            *
+ * Purpose:                                                                   *
+ *     find and set the requested pre-shared key upon GnuTLS request          *
+ *                                                                            *
+ * Parameters:                                                                *
+ *     session      - [IN] not used                                           *
+ *     psk_identity - [IN] PSK identity for which the PSK should be searched  *
+ *                         and set                                            *
+ *     key          - [OUT pre-shared key allocated and set                   *
+ *                                                                            *
+ * Return value:                                                              *
+ *     0  - required PSK successfully found and set                           *
+ *     -1 - an error occurred                                                 *
  *                                                                            *
  * Comments:                                                                  *
  *     A callback function, its arguments are defined in GnuTLS.              *
@@ -1598,6 +2007,37 @@ static void	zbx_log_ciphersuites(const char *title1, const char *title2, const i
 		zbx_free(msg);
 	}
 }
+#elif defined(HAVE_MBEDTLS21)
+/******************************************************************************
+ *                                                                            *
+ * Function: zbx_log_ciphersuites                                             *
+ *                                                                            *
+ * Purpose: write names of enabled mbed TLS ciphersuites into Zabbix log for  *
+ *          debugging                                                         *
+ *                                                                            *
+ * Parameters:                                                                *
+ *     title1     - [IN] name of the calling function                         *
+ *     title2     - [IN] name of the group of ciphersuites                    *
+ *     cipher_ids - [IN] list of ciphersuite ids, terminated by 0             *
+ *                                                                            *
+ ******************************************************************************/
+static void	zbx_log_ciphersuites(const char *title1, const char *title2, const int *cipher_ids)
+{
+	if (SUCCEED == zabbix_check_log_level(LOG_LEVEL_DEBUG))
+	{
+		char		*msg = NULL;
+		size_t		msg_alloc = 0, msg_offset = 0;
+		const int	*p;
+
+		zbx_snprintf_alloc(&msg, &msg_alloc, &msg_offset, "%s() %s ciphersuites:", title1, title2);
+
+		for (p = cipher_ids; 0 != *p; p++)
+			zbx_snprintf_alloc(&msg, &msg_alloc, &msg_offset, " %s", mbedtls_ssl_get_ciphersuite_name(*p));
+
+		zabbix_log(LOG_LEVEL_DEBUG, "%s", msg);
+		zbx_free(msg);
+	}
+}
 #elif defined(HAVE_GNUTLS)
 /******************************************************************************
  *                                                                            *
@@ -1684,7 +2124,7 @@ static void	zbx_log_ciphersuites(const char *title1, const char *title2, SSL_CTX
 }
 #endif
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS)
 /******************************************************************************
  *                                                                            *
  * Function: zbx_print_rdn_value                                              *
